/*
 * Copyright (c) 2013, Linz Center of Mechatronics GmbH (LCM), web: www.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. web: x2c.lcm.at
 * $LastChangedRevision: 4463 $
 * $LastChangedDate:: 2026-08-17 13:59:56 +0200#$
 */
/* USERCODE-BEGIN:Description */
/* Description: */
/* USERCODE-END:Description */

package at.lcm.x2c.library.control;

import at.lcm.x2c.core.structure.*;
import at.lcm.bu21.general.dtypes.*;

/* USERCODE-BEGIN:Imports */
/* USERCODE-END:Imports */

@SuppressWarnings("unused")
public class ConvFnc_AdaptivePT1_Float32 extends JavaConversionFunction {
    private static final long serialVersionUID = 1L;

    @Override
    public void convertMaskToImplementation() throws Exception {
        MaskDouble VMaskVal = (MaskDouble)this.getMaskParameter("V").getMaskDataType();
        TNumeric VMaskData = (TNumeric)VMaskVal.getData();
        double mp_V = VMaskData.getReal(0, 0);
        MaskDouble fmaxMaskVal = (MaskDouble)this.getMaskParameter("fmax").getMaskDataType();
        TNumeric fmaxMaskData = (TNumeric)fmaxMaskVal.getData();
        double mp_fmax = fmaxMaskData.getReal(0, 0);
        MaskDouble ts_factMaskVal = (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
        TNumeric ts_factMaskData = (TNumeric)ts_factMaskVal.getData();
        double mp_ts_fact = ts_factMaskData.getReal(0, 0);
        MaskComboBox methodMaskVal = (MaskComboBox)this.getMaskParameter("method").getMaskDataType();
        TString methodMaskData = (TString)methodMaskVal.getData();
        String mp_method = methodMaskData.getString();

        TNumeric w_scaleCtrVal = this.getImplementationParameterData("w_scale");
        double cp_w_scale = Double.NaN;
        TNumeric gainCtrVal = this.getImplementationParameterData("gain");
        double cp_gain = Double.NaN;

        /* Check if sample time factor is an integer value */
        if (Math.rint(mp_ts_fact) != mp_ts_fact) {
            throw new Exception("Sample time factor must be a whole number");
        }
        /* Check if sample time factor is within the valid range (upper limit defined by unsigned 16-bit integer range) */
        if ((mp_ts_fact < 1.0) || (mp_ts_fact > 65535.0)) {
            throw new Exception("Sample time factor must be at least 1 and at most 65535");
        }
        /* Block sample time */
        double bp_ts = mp_ts_fact * this.getDedicatedBlock().getModel().getSampleTime();
        /* Check if Block sample time has a valid value */
        if (bp_ts <= 0.0) {
            throw new Exception("Block sample time must be greater than zero");
        }

        /* ATTENTION: */
        /* The M2I conversion function may either use the mp_* or *MaskVal value to get the Mask Parameter value */
        /* For new or updated implementations, the mp_* value shall be used where possible */
        /* Currently, the mp_* value cannot be used for getting non-scalar Mask Parameter data but will return only the first element for these */
        /* The Implementation Parameter assignment variables cp_* can and shall be used for all Implementation Parameter data types */

        /* INFO: Implementation data assignment for array types when using the cp_* variables */
        /* If the cp_* parameter is a FLASH ARRAY, the cp_* variable is assigned an array type but without an actual array */
        /* The M2I conversion function has to assign an array with the correct size and fill it with content */
        /* If the cp_* parameter is a RAM ARRAY, the cp_* variable is assigned an array with the correct size */
        /* The first element is assigned an invalid value while the other elements are (auto)initialized with zero */
        /* The M2I conversion function has to fill the array with content */

        /* Mask parameter values */
        /* mp_V OR VMaskVal (Number) */
        /* mp_fmax OR fmaxMaskVal (Number) */
        /* mp_ts_fact OR ts_factMaskVal (Number) */
        /* mp_method OR methodMaskVal (String) */

        /* USERCODE-BEGIN:ConvMaskToImplementation */
		double w_scale;
		double gain, fmax;
		double Ts = 0;
		int ts_fact;

		/* get parameter */
		gain = Double.valueOf(VMaskVal.getValue());
		fmax = 1; /* input fc is in Hz -> no need for scaling */
		ts_fact = Double.valueOf(ts_factMaskVal.getValue()).intValue();

		/* validate parameter */
		fmax = Math.abs(fmax);
		if (ts_fact <= 0) {
			ts_fact = 1;
		}

		/* calculate sample time */
		Ts = ts_fact * this.getDedicatedBlock().getModel().getSampleTime();

		/*
		 * Zero order hold (zoh): G(s) = V/(s/w + 1) -> G(z) = V*(exp(w*T)-1)/(z*exp(w*T)-1)
		 */
		w_scale = -2 * Math.PI * Ts * fmax;

		/* set controller parameter values */
		gainCtrVal.setReal(0, 0, gain);
		w_scaleCtrVal.setReal(0, 0, w_scale);

        /* USERCODE-END:ConvMaskToImplementation */

        /* Implementation Parameter values */
        /* cp_w_scale OR w_scaleCtrVal (Value) */
        /* cp_gain OR gainCtrVal (Value) */

        if (Double.isNaN(cp_w_scale)) {
            this.setImplementationParameterData("w_scale", w_scaleCtrVal);
        } else {
            this.setImplementationParameterData("w_scale", new TNumeric(cp_w_scale));
        }
        if (Double.isNaN(cp_gain)) {
            this.setImplementationParameterData("gain", gainCtrVal);
        } else {
            this.setImplementationParameterData("gain", new TNumeric(cp_gain));
        }
    }

    @Override
    public void convertImplementationToMask() throws Exception {
        MaskDouble VMaskVal = (MaskDouble)this.getMaskParameter("V").getMaskDataType();
        TNumeric VMaskData = (TNumeric)VMaskVal.getData();
        double mp_V = Double.NaN;
        MaskDouble fmaxMaskVal = (MaskDouble)this.getMaskParameter("fmax").getMaskDataType();
        TNumeric fmaxMaskData = (TNumeric)fmaxMaskVal.getData();
        double mp_fmax = Double.NaN;
        MaskDouble ts_factMaskVal = (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
        TNumeric ts_factMaskData = (TNumeric)ts_factMaskVal.getData();
        double mp_ts_fact = ts_factMaskData.getReal(0, 0);
        MaskComboBox methodMaskVal = (MaskComboBox)this.getMaskParameter("method").getMaskDataType();
        TString methodMaskData = (TString)methodMaskVal.getData();
        String mp_method = null;

        TNumeric w_scaleCtrVal = this.getImplementationParameterData("w_scale");
        double cp_w_scale = w_scaleCtrVal.getReal(0, 0);
        TNumeric gainCtrVal = this.getImplementationParameterData("gain");
        double cp_gain = gainCtrVal.getReal(0, 0);

        /* Check if sample time factor is an integer value */
        if (Math.rint(mp_ts_fact) != mp_ts_fact) {
            throw new Exception("Sample time factor must be a whole number");
        }
        /* Check if sample time factor is within the valid range (upper limit defined by unsigned 16-bit integer range) */
        if ((mp_ts_fact < 1.0) || (mp_ts_fact > 65535.0)) {
            throw new Exception("Sample time factor must be at least 1 and at most 65535");
        }
        /* Block sample time */
        double bp_ts = mp_ts_fact * this.getDedicatedBlock().getModel().getSampleTime();
        /* Check if Block sample time has a valid value */
        if (bp_ts <= 0.0) {
            throw new Exception("Block sample time must be greater than zero");
        }

        /* ATTENTION: */
        /* The I2M conversion function may either use the cp_* or *CtrlVal value to get the Implementation Parameter value */
        /* For new or updated implementations, the cp_* value shall be used for all Implementation Parameter data types */
        /* The Mask Parameter assignment variables cp_* shall be used where possible */
        /* Currently, the mp_* variable assignment value cannot be used for setting non-scalar Mask Parameter data */

        /* Implementation Parameter values */
        /* cp_w_scale OR w_scaleCtrVal (Value) */
        /* cp_gain OR gainCtrVal (Value) */

        /* USERCODE-BEGIN:ConvImplementationToMask */
		double Ts = 0;
		int ts_fact;
		double gain, w_scale;

		/* get controller parameter */
		w_scale = w_scaleCtrVal.getReal(0, 0);
		gain = gainCtrVal.getReal(0, 0);

		/* get sample time information from model (sample time information can't be obtained from target) */
		ts_fact = Double.valueOf(ts_factMaskVal.getValue()).intValue();
		Ts = ts_fact * this.getDedicatedBlock().getModel().getSampleTime();

		/* set mask parameter */
		VMaskData.setReal(0, 0, gain);
		fmaxMaskData.setReal(0, 0, 1); /* input fc is in Hz -> no need for scaling */
		ts_factMaskData.setReal(0, 0, ts_fact);

        /* USERCODE-END:ConvImplementationToMask */

        /* Mask parameter values */
        /* mp_V OR VMaskVal (Number) */
        /* mp_fmax OR fmaxMaskVal (Number) */
        /* mp_ts_fact OR ts_factMaskVal (Number) */
        /* mp_method OR methodMaskVal (String) */

        if (Double.isNaN(mp_V)) {
            this.getMaskParameter("V").setValue(VMaskData.toFullString());
        } else {
            this.getMaskParameter("V").setValue(new TNumeric(mp_V).toFullString());
        }
        if (Double.isNaN(mp_fmax)) {
            this.getMaskParameter("fmax").setValue(fmaxMaskData.toFullString());
        } else {
            this.getMaskParameter("fmax").setValue(new TNumeric(mp_fmax).toFullString());
        }
        if (mp_method == null) {
            this.getMaskParameter("method").setValue(methodMaskData.getString());
        } else {
            this.getMaskParameter("method").setValue(mp_method);
        }
    }
}
